import redis

r = redis.Redis(host='localhost', port=6379, db=0, decode_responses=True)
r.set("datacenters_cnt", 1)
all_keys = list(r.hgetall('datacenters_hash').keys())
if all_keys:
    r.hdel('datacenters_hash', *all_keys)

def add_datacenter(datacenter: str):
    cnt = int(r.get("datacenters_cnt"))
    r.hset("datacenters_hash", cnt, datacenter)
    r.incr("datacenters_cnt")
    r.set("roundrobin_cnt", 1)

def rr_get():
    cnt = int(r.get("datacenters_cnt"))
    rr  = int(r.get("roundrobin_cnt"))
    if rr + 1 >= cnt:
        r.set("roundrobin_cnt", 1)
    else:
        r.incr("roundrobin_cnt")
    return str(r.hget("datacenters_hash", rr))

def new_user(username: str, token: str):
    if not r.hexists("users", token):
        r.hset("users", token, username)

def get_user(token: str):
    user = str(r.hget("users", token))
    return user

def set_token(username: str, datacenter: str, token: str):
    r.hset(f"tokens:{username}", datacenter, token)

def get_datacenter_token(username: str, datacenter: str):
    return str(r.hget(f"tokens:{username}", datacenter))